#!/usr/bin/env python
# GPIOstate.py : surveillance des tats des entres GPIO du Raspberry Pi
# Affiche les hangements d'tat des broches sur P1
# Broches non GPIO indiques comme x

import RPi.GPIO as GPIO

print "Affichage tats broches d'entre GPIO"
print "Ctrl C pour quitter"

boardRevision =  GPIO.RPI_REVISION
 # Dfinition des broches  utiliser
if boardRevision == 1:
     pinout = [-1,-1,0,-1,1,-1,4,14,-1,15,17,18,21,-1,22,23,-1,24,10,-1,9,25,11,8,-1,7]
if boardRevision == 2:    
     pinout = [-1,-1,2,-1,3,-1,4,14,-1,15,17,18,27,-1,22,23,-1,24,10,-1,9,25,11,8,-1,7] 

GPIO.setmode(GPIO.BCM) # Vraie numrotation GPIO
inputState = [ 5 for temp in range (0,26)] # Init du tableau de niveaux des entres

for pin in range(0,26): # Configure broches en entre
  if pinout[pin] != -1:
     GPIO.setup(pinout[pin],GPIO.IN, pull_up_down=GPIO.PUD_UP)
     # Remplacez la ligne ci-dessus par la suivante pour voir entre flottante
     # GPIO.setup(pinout[pin],GPIO.IN, pull_up_down=GPIO.PUD_OFF) 
 
while True: # Boucle principale infinie
   needUpdate = False
   for check in range(0,26): # Lecture de chaque entre
     if pinout[check] != -1:
       if(GPIO.input(pinout[check])):
          latestState = 1
       else:
          latestState = 0
       if(latestState != inputState[check]):
           needUpdate = True
           print "GPIO ", pinout[check], ", nouvel tat logique ", latestState
           inputState[check] = latestState
   if needUpdate: # Afficher tous les tats
     print "Etat actuel"
     for row in range(1,-1, -1):
        for show in range(row,26,2) :
          if inputState[show] != 5:
            print inputState[show],
          else:  
            print "x",
        print " "
     
 # Fin de boucle principale 


