#!/usr/bin/python
# Fichier copyCat.py
# Lancer avec sudo python copyCat.py

import RPi.GPIO as GPIO
from time import sleep
import random
import pygame
from pygame.locals import *

pygame.init()
pygame.mixer.quit()
pygame.mixer.init()

def lireAppui():
   tstAppui = False
   while tstAppui == False:
    for test in range(0,4):
      if GPIO.input(boutons[test]) == False: # Appui maintenu
         GPIO.output(leds[test],1)
         sonCouleur[test].play()
         tstAppui = True
         sleep(0.05)      # Dlai gestion rebond
         while GPIO.input(boutons[test]) == False: #Attendre fin appui
            sleep(0.05)
         GPIO.output(leds[test],0)
         return test
         
def direSeq(longueur):
   for numo in range(0,longueur):
      sonCouleur[sequence[numo]].play()
      GPIO.output(leds[sequence[numo]],1) # Allumer LED
      sleep(1.2)
      GPIO.output(leds[sequence[numo]],0) # Eeindre LED
      sleep(0.5)

def relireSeq(longueur):
    sonDebut.play()
    print"A vous de jouer"
    for pression in range(0,longueur):
       tentative = lireAppui()
       # Dcommenter la suivante pour afficher les boutons
       #print"Appui sur ", couleurs[tentative], " chercher",couleurs[sequence[pression]]
       # Mais rend le jeu trop facile
       if tentative != sequence[pression]:
          sleep(0.8)
          return -1
    return 1
   
couleurs = ["rouge", "vert", "jaune", "bleu" ]
# couleurs = ["bleu","rouge", "vert", "jaune"] # Pour jeu plus coriace
print "Chargement des fichiers sons"
sonCouleur = [ pygame.mixer.Sound("sounds/"+couleurs[c]+".ogg") for c in range(0,4)]
sonDebut = pygame.mixer.Sound("sounds/go.ogg")
sonPerdu = pygame.mixer.Sound("sounds/doh.ogg")
longMax = 35
sequence = [ random.randint(0,3) for c in range(0,longMax)] 

leds = [14, 15, 18, 23]
boutons = [24, 25, 8, 7]

print"Bienvenue au Raspi - CopyCat, memoire et observation"
print"Ctrl-C pour quitter"
GPIO.setmode(GPIO.BCM)  # Numros de broches GPIO rels
GPIO.setwarnings(False) # Elimine les warnings au redmarrage
for pin in leds:
   GPIO.setup(pin, GPIO.OUT)
   GPIO.output(pin, 0) # turn LEDs off
for pin in boutons:
   GPIO.setup(pin, GPIO.IN, pull_up_down=GPIO.PUD_UP)
essaisMax = 3

while True: # Boucle principale
  essais = 0  # Nombre d'essais actuel
  # Gnrer une nouvelle squence
  for c in range(0,longMax):
     sequence[c] = random.randint(0,3)
  seqOk = 2
  while essais < essaisMax: # Nombre d'essais avant rinit
     print "une sequence de",seqOk
     direSeq(seqOk)
     if relireSeq(seqOk) != -1:   
        seqOk = seqOk + 1
        print"Bien - une de plus maintenant"
        essais = 0 # Rinit du nombre d'essais
     else:
         essais = essais +1
         print"Faux",essais,"essai"
         if essais < essaisMax:
            sonPerdu.play()
            print"nouvel essai"
     sleep(1.5)
     if seqOk > longMax:
        print"Un vrai maestro"
        exit() # On subodore de la triche
  sonPerdu.play()
  print"Game over - Score de",seqOk-1
  print"Essayez encore !"
  sleep(2.0)
