# -*- coding: cp1252 -*-
# PiBuster du livre Raspberry Pi pour les nuls
import pygame, sys, time, random 
from pygame.locals import *

pygame.init()

surfaJeu=pygame.display.set_mode((440,480)) 
pygame.display.set_caption('PiBuster') 
pygame.mouse.set_visible(0)

OMBRE      = (192, 192, 192) 
BLANC      = (255, 255, 255) 
VERTCLAIR  = (  0, 255,   0) 
VERT       = (  0, 200,   0) 
BLEU       = (  0,   0, 128) 
BLEUCLAIR  = (  0,   0, 255) 
ROUGE      = (200,   0,   0) 
ROUGECLAIR = (255, 100, 100) 
MAUVE      = (102,   0, 102) 
MAUVECLAIR = (153,   0, 153)

surfaJeu.fill(BLANC) 
pygame.display.update()

pygame.draw.rect(surfaJeu,MAUVE,(16,16,406,2)) 
pygame.draw.rect(surfaJeu,MAUVE,(16,16,2,440)) 
pygame.draw.rect(surfaJeu,MAUVE,(422,16,2,440))

mappe = [ 
       #-----0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9-- 
       [0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0], 
       [0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0], 
       [0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0], 
       [0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0], 
       [0,0,0,0,0,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0], 
       [0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0], 
       [0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0], 
       [0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0], 
       [0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0], 
       [0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0], 
       [0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0], 
       [0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
      ]

def xReel(x): 
    x = x * 20 
    return x 

def yReel(y): 
    y = y * 20 
    return y

def briqueTracer(xcoord,ycoord,col): 
    if col == 1: 
        coulCadre=VERT 
        coulLumi=VERTCLAIR 
    else: 
        coulCadre=ROUGE 
        coulLumi=ROUGECLAIR 
    pygame.draw.rect (surfaJeu,coulCadre,(xReel(xcoord),yReel(ycoord),20,20)) 
    pygame.draw.rect(surfaJeu,coulLumi,(xReel(xcoord),yReel(ycoord),2,20))
    pygame.draw.rect(surfaJeu,coulLumi,(xReel(xcoord),yReel(ycoord),20,2))
    pygame.draw.rect(surfaJeu,OMBRE,(xReel(xcoord)+18,yReel(ycoord),2,20)) 
    pygame.draw.rect(surfaJeu,OMBRE,(xReel(xcoord),yReel(ycoord)+18,20,2))

nBriques = 0 
for x in range(1,21): 
    for y in range(1,20): 
        if mappe[y-1][x-1]!=0: 
            briqueTracer(x,y,mappe[y-1][x-1]) 
            nBriques+=1 
pygame.display.update()

# Prparation de la raquette et RAZ du score
raqx = random.randint(1,19) 
RAQY = 20 
raqTracer(raqx) 
score = 0

def raqTracer(x): 
    pygame.draw.rect(surfaJeu,MAUVECLAIR,(xReel(x),yReel(RAQY),40,4))
    pygame.draw.rect(surfaJeu,MAUVE,(xReel(x),yReel(RAQY)+4,40,6))
    pygame.draw.rect(surfaJeu,OMBRE,(xReel(x),yReel(RAQY)+10,40,2))
    pygame.draw.rect(surfaJeu,OMBRE,(xReel(x)+38,yReel(RAQY),2,12))

def blanchir(x,y): 
    pygame.draw.rect(surfaJeu,BLANC,(xReel(x),yReel(y),20,20)) 

def raqMasquer(x): 
    blanchir(x,RAQY) 
    blanchir(x+1,RAQY)

