# PiBuster du livre Raspberry Pi pour les nuls
import pygame, sys, time, random 
from pygame.locals import *

pygame.init()

surfaJeu=pygame.display.set_mode((440,480)) 
pygame.display.set_caption('PiBuster') 
pygame.mouse.set_visible(0)

OMBRE      = (192, 192, 192) 
BLANC      = (255, 255, 255) 
VERTCLAIR  = (  0, 255,   0) 
VERT       = (  0, 200,   0) 
BLEU       = (  0,   0, 128) 
BLEUCLAIR  = (  0,   0, 255) 
ROUGE      = (200,   0,   0) 
ROUGECLAIR = (255, 100, 100) 
MAUVE      = (102,   0, 102) 
MAUVECLAIR = (153,   0, 153)

surfaJeu.fill(BLANC) 
pygame.display.update()

pygame.draw.rect(surfaJeu,MAUVE,(16,16,406,2)) 
pygame.draw.rect(surfaJeu,MAUVE,(16,16,2,440)) 
pygame.draw.rect(surfaJeu,MAUVE,(422,16,2,440))

mappe = [ 
       #-----0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9-- 
       [0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0], 
       [0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0], 
       [0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0], 
       [0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0], 
       [0,0,0,0,0,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0], 
       [0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0], 
       [0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0], 
       [0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0], 
       [0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0], 
       [0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0], 
       [0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0], 
       [0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
       [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 
      ]

def xReel(x): 
    x = x * 20 
    return x 

def yReel(y): 
    y = y * 20 
    return y

def briqueTracer(xcoord,ycoord,col): 
    if col == 1: 
        coulCadre=VERT 
        coulLumi=VERTCLAIR 
    else: 
        coulCadre=ROUGE 
        coulLumi=ROUGECLAIR 
    pygame.draw.rect (surfaJeu,coulCadre,(xReel(xcoord),yReel(ycoord),20,20)) 
    pygame.draw.rect(surfaJeu,coulLumi,(xReel(xcoord),yReel(ycoord),2,20))
    pygame.draw.rect(surfaJeu,coulLumi,(xReel(xcoord),yReel(ycoord),20,2))
    pygame.draw.rect(surfaJeu,OMBRE,(xReel(xcoord)+18,yReel(ycoord),2,20)) 
    pygame.draw.rect(surfaJeu,OMBRE,(xReel(xcoord),yReel(ycoord)+18,20,2))

def raqTracer(x): 
    pygame.draw.rect(surfaJeu,MAUVECLAIR,(xReel(x),yReel(RAQY),40,4))
    pygame.draw.rect(surfaJeu,MAUVE,(xReel(x),yReel(RAQY)+4,40,6))
    pygame.draw.rect(surfaJeu,OMBRE,(xReel(x),yReel(RAQY)+10,40,2))
    pygame.draw.rect(surfaJeu,OMBRE,(xReel(x)+38,yReel(RAQY),2,12))

def blanchir(x,y): 
    pygame.draw.rect(surfaJeu,BLANC,(xReel(x),yReel(y),20,20)) 

def raqMasquer(x): 
    blanchir(x,RAQY) 
    blanchir(x+1,RAQY)

def balleTracer(x,y): 
    pygame.draw.circle(surfaJeu,BLEU,(xReel(x)+10,yReel(y)+10),10,0)
    pygame.draw.circle(surfaJeu,BLEUCLAIR,(xReel(x)+6,yReel(y)+6),2,0)

def affTexte(text): 
    fontObj=pygame.font.Font('freesansbold.ttf',64) 
    textsurface=fontObj.render(text, True, MAUVE, BLANC) 
    textRectObj=textsurface.get_rect() 
    textRectObj.center=(220,200) 
    surfaJeu.blit(textsurface,textRectObj) 
    pygame.display.update()

def finirDefaite(): 
    affTexte('GAME OVER') 
    time.sleep(8) 
    finirQuitter() 

def finirVictoire(): 
    affTexte('VICTOIRE!') 
    time.sleep(8) 
    finirQuitter()

def finirQuitter(): 
    pygame.quit() 
    sys.exit()

def testerVicDef(): 
    if score == nBriques: 
        return True 
    else: 
        return False

# Fonction principale (MAIN)
nBriques = 0 
for x in range(1,21): 
    for y in range(1,20): 
        if mappe[y-1][x-1]!=0: 
            briqueTracer(x,y,mappe[y-1][x-1]) 
            nBriques+=1 

# Configuration de la balle
ballx=0 
bally=0 
while mappe[bally-1][ballx-1]!=0 or ballx==0: 
    ballx=random.randint(1,20) 
    bally=random.randint(1,7) 

ballxdir=1 
ballydir=-1 
balleTracer(ballx,bally)

# Configuration de la raquette et RAZ du score
raqx = random.randint(1,19) 
RAQY = 20 
raqTracer(raqx) 
score = 0

FPS = 20 
fpsClock = pygame.time.Clock() 
pygame.key.set_repeat(1,1)

# Actualisation de l'affichage et petite pause
pygame.display.update() 
time.sleep(2.5)
